unit lfmosfuncwin;

{$mode objfpc}{$H+}

interface

uses Windows, ComCtrls;

procedure SetListViewImgListToSys(AListView :TCustomListView; ALarge: Boolean);

function GetFileSysImageIndex(AFName: string): Integer;

//AListView.Parent must be valid
//AOverlayindex=0 nothing, =1 shared, =2 linked
procedure SetListViewOverlayIndex(AListView :TCustomListView; AItemIndex, AOverlayIndex: Integer);

function GetListViewOverlayIndex(AFName: string): Integer;

procedure ShellExec(AFName, AFParam: string); //execute application


implementation

const
  SHGFI_SMALLICON         = $000000001;
  SHGFI_LARGEICON         = $000000000;
  SHGFI_SYSICONINDEX      = $000004000;
  SHGFI_ICON              = $000000100;
  IsImgLarge: array[Boolean] of Integer = (SHGFI_SMALLICON, SHGFI_LARGEICON);
  //attrib consts for overlay-image
  SHGFI_ATTR_SPECIFIED    = $000020000;
  SHGFI_ATTRIBUTES        = $000000800;
  SFGAO_LINK              = $00010000;
  SFGAO_SHARE             = $00020000;

function GetSysImageListHandle(ALarge: Boolean): HIMAGELIST;
var aFileInfo: TSHFileInfo;
begin
  //don't needed initial zereo: ZeroMemory(@aFileInfo,sizeof(TSHFileInfo));
  Result := SHGetFileInfo('', 0, aFileInfo, SizeOf(aFileInfo), SHGFI_SYSICONINDEX or IsImgLarge[ALarge]);
end;

procedure SetListViewImgListToSys(AListView :TCustomListView; ALarge: Boolean);
begin
  ListView_SetImageList(AListView.Handle,GetSysImageListHandle(ALarge), IsImgLarge[ALarge]); //SHGFI_SMALLICON);
end;

function GetFileSysImageIndex(AFName: string): Integer;
var aFileInfo: TSHFileInfo;
begin
  //don't needed initial zereo: ZeroMemory(@aFileInfo,sizeof(TSHFileInfo));
  SHGetFileInfo(PChar(AFName),0,aFileInfo, SizeOf(aFileInfo), SHGFI_ICON or SHGFI_SYSICONINDEX);
  //aFileInfo.szTypeName;  //with SHGFI_TYPENAME
  //aFileInfo.szDisplayName; //with SHGFI_DISPLAYNAME
  //and in shellapi look for overlays SHGFI_LINKOVERLAY ....
  Result:=aFileInfo.iIcon;
end;

procedure SetListViewOverlayIndex(AListView :TCustomListView; AItemIndex, AOverlayIndex: Integer);
begin
  ListView_SetItemState(AListView.Handle, AItemIndex, IndexToOverlayMask(AOverlayIndex), LVIS_OVERLAYMASK);
end;

function GetListViewOverlayIndex(AFName: string): Integer;
var aFileInfo: TSHFileInfo;
begin
  //don't needed initial zereo: ZeroMemory(@aFileInfo,sizeof(TSHFileInfo));
  Result := SHGetFileInfo(PChar(AFName), 0, aFileInfo, SizeOf(aFileInfo), SHGFI_ATTRIBUTES or SHGFI_ATTR_SPECIFIED or SFGAO_LINK or SFGAO_SHARE);
  if ((aFileInfo.dwAttributes or SFGAO_LINK) = aFileInfo.dwAttributes) then Result:=2
  else if ((aFileInfo.dwAttributes or SFGAO_SHARE) = aFileInfo.dwAttributes) then Result:=1
  else Result:=0;
end;

procedure ShellExec(AFName, AFParam: string);
begin
  ShellExecute(0, 'open', PChar(AFName), PChar(AFParam), nil, SW_SHOWNORMAL);
end;

end.

